---
title: "Output formats"
slug: "output-formats"
updated: 2025-11-21T10:28:37Z
published: 2025-11-21T10:28:37Z
---

> ## Documentation Index
> Fetch the complete documentation index at: https://docs.supermetrics.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Output formats

The Supermetrics API supports several output formats for extracting query data. Each format has its own dedicated endpoint, available for [get data queries](/v1-api/apidocs/query-data) and to short URLs.

- [JSON (default)](/v1-api/apidocs/output-formats#json-default)
- [Key-value pairs JSON](/v1-api/apidocs/output-formats#keyvalue-pairs-json)
- [Newline delimited JSON](/v1-api/apidocs/output-formats#newline-delimited-json)
- [Parquet (Preview)](/v1-api/apidocs/output-formats#parquet-preview)
- [Postman](/v1-api/apidocs/output-formats#postman)
- [Power BI](/v1-api/apidocs/output-formats#power-bi)
- [Qlik](/v1-api/apidocs/output-formats#qlik)
- [CSV](/v1-api/apidocs/output-formats#csv)
- [TSV](/v1-api/apidocs/output-formats#tsv)
- [Limitations](/v1-api/apidocs/output-formats#limitations)
- [Missing a format?](/v1-api/apidocs/output-formats#missing-a-format)

## JSON (default)

Default output format of the Supermetrics API is JSON. Please see get data for response structure and examples.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/json` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/json` |

### Settings

- [**no_json_keys**](/v1-api/apidocs/settings#general-settings) setting is by default true
- Optional setting [**decode_json_fields**](/v1-api/apidocs/settings#general-settings)

### Features

- Supports [result pagination](/v1-api/apidocs/pagination)
- Supports field's [key-property](/v1-api/apidocs/fields#field-properties)

## Key-value pairs JSON

Output format for query results in [JSON](https://en.wikipedia.org/wiki/JSON) without any metadata. Data is structured as a list of key-value pair objects, where keys are the requested field id values. This common data structure is understood by a wide range of solutions, including Excel, Power BI and Azure Logic Apps.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/keyjson` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/keyjson` |

### Settings

- [**no_headers**](/v1-api/apidocs/settings#general-settings) setting is by default true
- Optional setting [**no_json_keys**](/v1-api/apidocs/settings#general-settings)
- Optional setting [**decode_json_fields**](/v1-api/apidocs/settings#general-settings)

### Features

- Supports field's [key-property](/v1-api/apidocs/fields#field-properties)

## Newline delimited JSON

This output format implements the [NDJSON](https://github.com/ndjson/ndjson-spec) specification for line separated JSON. Response consists only of the query results, where each new line is a single row of data. Each data row is structured as a JSON object, where keys are the requested field id values.

This form of [JSON streaming](https://en.wikipedia.org/wiki/JSON_streaming) is preferred by some systems, such as [BigQuery](https://cloud.google.com/bigquery/docs/loading-data-cloud-storage-json) and [Azure Data Factory](https://docs.microsoft.com/en-us/azure/data-factory/format-json#json-file-patterns).

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/ndjson` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/ndjson` |

### Settings

- [**no_headers**](/v1-api/apidocs/settings#general-settings) setting is by default true
- Optional setting [**no_json_keys**](/v1-api/apidocs/settings#general-settings)
- Optional setting [**decode_json_fields**](/v1-api/apidocs/settings#general-settings)

### Features

- Supports result [pagination](/v1-api/apidocs/pagination)
- Supports field's [key-property](/v1-api/apidocs/fields#field-properties)

## Parquet (Preview)

Output format to get query results as a [Apache Parquet](https://en.wikipedia.org/wiki/Apache_Parquet) file – columnar data storage format used in Apache Hadoop. Generated file is configured for Parquet version 1.0.

Parquet files are supported by various data processing services, such [Azure Data Factory](https://learn.microsoft.com/en-us/azure/data-factory/format-parquet).

> [!NOTE]
> Please note that this output format is in Preview and it might not work for all queries, or for all services that accept Parquet files. Please let us know of any issues you might encounter to help us improve this output format.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/parquet` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/parquet` |

### Settings

- **clean_numeric_types** setting is by default true
- **dimensions_to_strings** setting is by default true
- Optional setting [**decode_json_fields**](/v1-api/apidocs/settings#general-settings)

### Features

- Supports result [pagination](/v1-api/apidocs/pagination)
- Supports field's [key-property](/v1-api/apidocs/fields#field-properties)

## Postman

Output format to import query request details into [Postman](https://www.postman.com/), a popular software for making HTTP requests. Response is a Postman collection v2.1. See Postman documentation for [how to import collections](https://learning.postman.com/docs/getting-started/importing-and-exporting-data/#importing-data-into-postman).

Please note that while accessing this output format does not perform the actual query, using invalid query parameter values do stop Postman from accepting the import.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/postman` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/postman` |

## Power BI

Output format as an HTML table, intended for integrations with [Power BI](https://en.wikipedia.org/wiki/Microsoft_Power_BI). This format can also be used when fetching data into Excel. See related [solution article](/v1/docs/how-to-connect-data-to-power-bi-using-the-supermetrics-api) for detailed instructions.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/powerbi` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/powerbi` |

## Qlik

Output format designed for integrations with [Qlik Sense](https://en.wikipedia.org/wiki/Qlik). Please see related [solution article](/v1/docs/how-to-connect-data-to-qlik-sense) on how to get started.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/qlik` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/qlik` |

## CSV

Output format as a CSV file, following [RFC 4180](https://datatracker.ietf.org/doc/html/rfc4180). Default delimiter is a comma and enclosing character is a quotation mark, when necessary. This format can also be used when fetching data into Excel and Power BI.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/csv` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/csv` |

## TSV

Output format as a TSV file, following [RFC 4180](https://datatracker.ietf.org/doc/html/rfc4180). Default delimiter is a tab and enclosing character is a quotation mark, when necessary. This format can also be when fetching data into Excel and Power BI.

### Endpoints

| **Get data** | `https://api.supermetrics.com/enterprise/v2/query/data/tsv` |
| --- | --- |
| **Short URL** | `https://api.supermetrics.com/enterprise/v2/query/s/:query_id/tsv` |

## Limitations

- Unless otherwise mentioned, output formats do not support [pagination](/v1-api/apidocs/pagination)
- Output formatting only applies to successfully executed queries. If an error occurs, the response uses the standard [JSON error response](/v1-api/apidocs/errors#error-response)

## Missing a format?

If you find that we are missing the output format you absolutely need, please [contact us](/v1-api/apidocs/support) or your Supermetrics representative, and let us know.
